/**
 * Restricted keys
 * "fetch"
 * "resolve"
 * "string"
 * "toString"
 * "__variables"
 */
import { type String } from 'ts-toolbelt';
export type TResolversWithValue = [string, string][];
export type TTypeMapVariableTypeUnit<T extends string = string> = T | 'string' | 'number';
export type TTypeMapVar = TTypeMapVariableTypeUnit[];
export type TTypeMapVarAsType<Var extends TTypeMapVar> = Var extends [infer Head, ...infer Rest] ? Rest extends TTypeMapVar ? Rest extends [] ? MapVariableTypeOfChildItem<Head> : (MapVariableTypeOfChildItem<Head> | TTypeMapVarAsType<Rest>) : string : string;
export type TTypeMapVariables = Record<string, TTypeMapVar>;
export type TTypeMapResolvers = Record<string, any>;
export type TGetTypeMapResolvers<TypeMap extends TTypeMap> = '__def' extends keyof TypeMap ? 'resolvers' extends keyof TypeMap['__def'] ? (keyof TypeMap['__def']['resolvers']) : string : string;
export type TTypeMapHasChildren<TypeMap extends TTypeMap> = TGetTypeMapResolvers<TypeMap> extends never ? true : false;
export type TTypeMap<Resolvers extends TTypeMapResolvers = TTypeMapResolvers, Variables extends TTypeMapVariables = {}> = {
    [K in FirstResolversSegment<Resolvers>]: TTypeMap<StripFirstResolversSegment<Resolvers>, any>;
} & {
    [K: string]: TTypeMap | TTypeMapDef<Resolvers, Variables>;
    __def?: TTypeMapDef<Resolvers, Variables>;
};
export type TTypeMapDef<Resolvers extends TTypeMapResolvers, Variables extends TTypeMapVariables> = {
    resolvers?: Resolvers;
    __variables?: Variables;
};
export type ResolverSegments<Resolver extends string | number | symbol> = Resolver extends string ? String.Split<Resolver, '.'> : [];
type FirstResolverSegment<Resolver extends string> = ResolverSegments<Resolver>[0];
type FirstResolversSegment<Resolvers extends TTypeMapResolvers> = Resolvers extends [infer First, ...infer Rest] ? First extends string ? Rest extends TTypeMapResolvers ? Rest extends [] ? FirstResolverSegment<First> : FirstResolverSegment<First> | FirstResolversSegment<Rest> : FirstResolverSegment<First> : never : never;
type StripFirstResolverSegment<Resolver extends string> = Resolver extends `${FirstResolverSegment<Resolver>}.${infer Rest}` ? Rest : '';
type StripFirstResolversSegment<Resolvers extends TTypeMapResolvers> = Resolvers extends [infer First, ...infer Rest] ? First extends string ? Rest extends TTypeMapResolvers ? Rest extends [] ? StripFirstResolverSegment<First> : StripFirstResolverSegment<First> | StripFirstResolversSegment<Rest> : StripFirstResolverSegment<First> : never : never;
type TTypeMapVariablesForResolver_Internal<TypeMap, Resolvers extends string[]> = Resolvers extends [
    infer Head,
    ...infer Rest
] ? Rest extends string[] ? Rest extends [] ? Head extends keyof TypeMap ? TypeMap[Head] extends {
    __def: any;
} ? TTypeMapMappedVars<TypeMap[Head]> : `TypeMap[${Head & string}] doesn't extend __def` : {
    __empty: 2;
} : Head extends keyof TypeMap ? TTypeMapVariablesForResolver_Internal<TypeMap[Head], Rest> : {
    __empty: 3;
} : never : never;
export type TTypeMapVariablesForResolver<TypeMap extends TTypeMap, Resolver extends TGetTypeMapResolvers<TypeMap>> = TTypeMapVariablesForResolver_Internal<TypeMap, ResolverSegments<Resolver>>;
export type TTypeMapNavigateToPath_Internal<TypeMap, RemainingPath extends string[], CurrentPath extends string[] = []> = RemainingPath extends [infer Head, ...infer Rest] ? Rest extends string[] ? Rest extends [] ? Head extends keyof TypeMap ? Head extends string ? TypeMap[Head] : `Head doesn't extend string (1)` : `Head doesn't extend keyof TypeMap (1)` : Head extends keyof TypeMap ? Head extends string ? TTypeMapNavigateToPath_Internal<TypeMap[Head], Rest, [...CurrentPath, Head]> : `Head doesn't extend string (2)` : `Head doesn't extend keyof TypeMap (2)` : never : never;
export type TTypeMapOfChild<TypeMap extends TTypeMap, Resolver extends TGetTypeMapResolvers<TypeMap>> = TTypeMapNavigateToPath_Internal<TypeMap, ResolverSegments<Resolver>>;
type VariablesOfChild<Child> = '__def' extends keyof Child ? '__variables' extends keyof Child['__def'] ? Child['__def']['__variables'] : {} : {};
type TTypeMapMappedVars_Internal<Vars extends TTypeMapVariables> = {
    [K in keyof Vars]: Vars[K] extends TTypeMapVar ? TTypeMapVarAsType<Vars[K]> : unknown;
};
export type TTypeMapMappedVars<TypeMap extends TTypeMap> = TTypeMapMappedVars_Internal<VariablesOfChild<TypeMap>>;
type MapVariableTypeOfChildItem<Variable> = Variable extends 'string' ? string : Variable extends 'number' ? number : Variable;
export type TStringAccessorPojo<Child> = keyof Omit<Child, '__def'> extends [] ? string : {
    [K in keyof Omit<Child, '__def'>]: TStringAccessorPojo<Child[K]>;
};
export {};
